100 REMark character code translator for QL text files where the
110 REMark matching characters exist in the PC character set
120 REMark this program translates what it can
130 REMark by Dilwyn Jones 1995
140 REMark needs Toolkit 2
150 REMark $$asmb=flp1_qlib_ext,0,12
160 REMark $$asmb=flp1_edline_code,0,10
170 REMark $$asmb=flp1_trpc_cfg,0,12
180 sd$=C_STRG$(1) : REMark source drive
190 dd$=C_STRG$(2) : REMark destination drive
200 IF Q_MYJOB <> 0 : OPEN #0,'con' : OPEN #1,'scr'
210 WINDOW 448,16,32,12 : PAPER 16 : INK 7 : BORDER 1,255 : CLS
220 WINDOW #0,448,100,32,27 : PAPER #0,0 : INK #0,7 : BORDER #0,1,255
230 CLS #0 : CURSOR 18,2
240 PRINT 'CONVERT QL TEXT FILES TO PC CHARACTER SET v';C_VERS$
250 CURSOR 354,2 : PRINT 'LINES:';
260 DIM tr$(255,20) : REMark up to 20 characters per translate
270 DIM c%(255) : REMark actual number of characters per translate
280 RESTORE
290 FOR a = 0 TO 255
300   READ cde%,c%(a)
310   tr$(a)=''
320   FOR b = 1 TO c%(a) : READ byte% : tr$(a)=tr$(a)&CHR$(byte%)
330 END FOR a
340 :
350 REPeat program
360   CURSOR 390,2 : CLS 4 : PRINT #0,'Source filename:';
370   source$ = EDLINE$(#0,41,sd$)
380   IF source$ = '' THEN EXIT program
390   sd$ = EXTRACT_DRIVE$(sd$,source$)
400   dest$ = dd$&fnm$
410   PRINT #0,'Destination filename:';
420   dest$ = EDLINE$(#0,41,dest$)
430   IF dest$ = '' THEN NEXT program
440   dd$ = EXTRACT_DRIVE$(dd$,dest$)
450   Q_ERR_ON 'open_in' : OPEN_IN #3,source$ : ifer = Q_ERR
460   Q_ERR_OFF 'open_in'
470   IF ifer < 0 THEN
480     BEEP 5000,50 : PRINT #0,'Oops, error ';ifer;' opening input file'
490     PAUSE 50 : NEXT program
500   END IF
510   Q_ERR_ON 'open_new' : OPEN_NEW #4,dest$ : ofer = Q_ERR
520   Q_ERR_OFF 'open_new'
530   IF ofer < 0 THEN
540     BEEP 5000,50 : PRINT #0,'Oops, error ';ofer;' opening output file'
550     PAUSE 50 : NEXT program
560   END IF
570   lf = 0
580   REPeat loop
590     IF EOF(#3):EXIT loop
600     cde% = CODE(INKEY$(#3))
610     IF cde% = 10 : lf = lf+1 : CURSOR 390,2 : PRINT lf;
620     PRINT #4,tr$(cde%);
630   END REPeat loop
640   CLOSE #3 : CLOSE #4
650   PRINT #0,'Translated ';lf;' lines of text'
660   PRINT #0,FILL$('-',74)
670 END REPeat program
680 PRINT #0,'Program Finished.'
690 PAUSE 50
700 STOP
710 :
720 REMark default 1:1 conversion, used as base program for new versions
730 REMark QL code,number of replacement bytes,destination bytes
740 DATA 0,1,0 : REMark NUL
750 DATA 1,1,1 : REMark
760 DATA 2,1,2 : REMark
770 DATA 3,1,3 : REMark
780 DATA 4,1,4 : REMark
790 DATA 5,1,5 : REMark
800 DATA 6,1,6 : REMark
810 DATA 7,1,7 : REMark BEL
820 DATA 8,1,8 : REMark BS
830 DATA 9,1,9 : REMark TAB
840 DATA 10,2,13,10 : REMark LF -> LF+CR
850 DATA 11,1,11 : REMark
860 DATA 12,1,12 : REMark
870 DATA 13,1,13 : REMark CR
880 DATA 14,1,14 : REMark
890 DATA 15,1,15 : REMark
900 DATA 16,1,16 : REMark
910 DATA 17,1,17 : REMark
920 DATA 18,1,18 : REMark
930 DATA 19,1,19 : REMark
940 DATA 20,1,20 : REMark
950 DATA 21,1,21 : REMark
960 DATA 22,1,22 : REMark
970 DATA 23,1,23 : REMark
980 DATA 24,1,24 : REMark
990 DATA 25,1,25 : REMark
1000 DATA 26,1,26 : REMark EOF
1010 DATA 27,1,27 : REMark
1020 DATA 28,1,28 : REMark
1030 DATA 29,1,29 : REMark
1040 DATA 30,1,30 : REMark
1050 DATA 31,1,31 : REMark
1060 DATA 32,1,32 : REMark
1070 DATA 33,1,33 : REMark !
1080 DATA 34,1,34 : REMark "
1090 DATA 35,1,35 : REMark #
1100 DATA 36,1,36 : REMark $
1110 DATA 37,1,37 : REMark %
1120 DATA 38,1,38 : REMark &
1130 DATA 39,1,39 : REMark '
1140 DATA 40,1,40 : REMark (
1150 DATA 41,1,41 : REMark )
1160 DATA 42,1,42 : REMark *
1170 DATA 43,1,43 : REMark +
1180 DATA 44,1,44 : REMark ,
1190 DATA 45,1,45 : REMark -
1200 DATA 46,1,46 : REMark .
1210 DATA 47,1,47 : REMark /
1220 DATA 48,1,48 : REMark 0
1230 DATA 49,1,49 : REMark 1
1240 DATA 50,1,50 : REMark 2
1250 DATA 51,1,51 : REMark 3
1260 DATA 52,1,52 : REMark 4
1270 DATA 53,1,53 : REMark 5
1280 DATA 54,1,54 : REMark 6
1290 DATA 55,1,55 : REMark 7
1300 DATA 56,1,56 : REMark 8
1310 DATA 57,1,57 : REMark 9
1320 DATA 58,1,58 : REMark :
1330 DATA 59,1,59 : REMark ;
1340 DATA 60,1,60 : REMark <
1350 DATA 61,1,61 : REMark =
1360 DATA 62,1,62 : REMark >
1370 DATA 63,1,63 : REMark ?
1380 DATA 64,1,64 : REMark @
1390 DATA 65,1,65 : REMark A
1400 DATA 66,1,66 : REMark B
1410 DATA 67,1,67 : REMark C
1420 DATA 68,1,68 : REMark D
1430 DATA 69,1,69 : REMark E
1440 DATA 70,1,70 : REMark F
1450 DATA 71,1,71 : REMark G
1460 DATA 72,1,72 : REMark H
1470 DATA 73,1,73 : REMark I
1480 DATA 74,1,74 : REMark J
1490 DATA 75,1,75 : REMark K
1500 DATA 76,1,76 : REMark L
1510 DATA 77,1,77 : REMark M
1520 DATA 78,1,78 : REMark N
1530 DATA 79,1,79 : REMark O
1540 DATA 80,1,80 : REMark P
1550 DATA 81,1,81 : REMark Q
1560 DATA 82,1,82 : REMark R
1570 DATA 83,1,83 : REMark S
1580 DATA 84,1,84 : REMark T
1590 DATA 85,1,85 : REMark U
1600 DATA 86,1,86 : REMark V
1610 DATA 87,1,87 : REMark W
1620 DATA 88,1,88 : REMark X
1630 DATA 89,1,89 : REMark Y
1640 DATA 90,1,90 : REMark Z
1650 DATA 91,1,91 : REMark [
1660 DATA 92,1,92 : REMark \
1670 DATA 93,1,93 : REMark ]
1680 DATA 94,1,94 : REMark ^
1690 DATA 95,1,95 : REMark _
1700 DATA 96,1,156 : REMark `
1710 DATA 97,1,97 : REMark a
1720 DATA 98,1,98 : REMark b
1730 DATA 99,1,99 : REMark c
1740 DATA 100,1,100 : REMark d
1750 DATA 101,1,101 : REMark e
1760 DATA 102,1,102 : REMark f
1770 DATA 103,1,103 : REMark g
1780 DATA 104,1,104 : REMark h
1790 DATA 105,1,105 : REMark i
1800 DATA 106,1,106 : REMark j
1810 DATA 107,1,107 : REMark k
1820 DATA 108,1,108 : REMark l
1830 DATA 109,1,109 : REMark m
1840 DATA 110,1,110 : REMark n
1850 DATA 111,1,111 : REMark o
1860 DATA 112,1,112 : REMark p
1870 DATA 113,1,113 : REMark q
1880 DATA 114,1,114 : REMark r
1890 DATA 115,1,115 : REMark s
1900 DATA 116,1,116 : REMark t
1910 DATA 117,1,117 : REMark u
1920 DATA 118,1,118 : REMark v
1930 DATA 119,1,119 : REMark w
1940 DATA 120,1,120 : REMark x
1950 DATA 121,1,121 : REMark y
1960 DATA 122,1,122 : REMark z
1970 DATA 123,1,123 : REMark {
1980 DATA 124,1,124 : REMark |
1990 DATA 125,1,125 : REMark }
2000 DATA 126,1,126 : REMark ~
2010 DATA 127,3,40,67,41 : REMark 
2020 DATA 128,1,132 : REMark 
2030 DATA 129,1,97 : REMark  to a
2040 DATA 130,1,134 : REMark 
2050 DATA 131,1,130 : REMark 
2060 DATA 132,1,148 : REMark 
2070 DATA 133,1,111 : REMark  to o (closest)
2080 DATA 134,1,237 : REMark 
2090 DATA 135,1,129 : REMark 
2100 DATA 136,1,135 : REMark 
2110 DATA 137,1,164 : REMark 
2120 DATA 138,1,145 : REMark 
2130 DATA 139,2,111,101 : REMark  to oe
2140 DATA 140,1,160 : REMark 
2150 DATA 141,1,133 : REMark 
2160 DATA 142,1,131 : REMark 
2170 DATA 143,1,137 : REMark 
2180 DATA 144,1,138 : REMark 
2190 DATA 145,1,136 : REMark 
2200 DATA 146,1,139 : REMark 
2210 DATA 147,1,161 : REMark 
2220 DATA 148,1,141 : REMark 
2230 DATA 149,1,140 : REMark 
2240 DATA 150,1,162 : REMark 
2250 DATA 151,1,149 : REMark 
2260 DATA 152,1,147 : REMark 
2270 DATA 153,1,163 : REMark 
2280 DATA 154,1,151 : REMark 
2290 DATA 155,1,150 : REMark 
2300 DATA 156,1,225 : REMark 
2310 DATA 157,1,155 : REMark 
2320 DATA 158,1,157 : REMark 
2330 DATA 159,1,96 : REMark 
2340 DATA 160,1,142 : REMark 
2350 DATA 161,1,65 : REMark  to A
2360 DATA 162,1,65 : REMark  to A
2370 DATA 163,1,144 : REMark 
2380 DATA 164,1,153 : REMark 
2390 DATA 165,1,79 : REMark  to O
2400 DATA 166,1,233 : REMark 
2410 DATA 167,1,154 : REMark 
2420 DATA 168,1,128 : REMark 
2430 DATA 169,1,165 : REMark 
2440 DATA 170,1,146 : REMark 
2450 DATA 171,2,79,69 : REMark  to OE
2460 DATA 172,1,224 : REMark 
2470 DATA 173,1,235 : REMark 
2480 DATA 174,1,233 : REMark 
2490 DATA 175,1,175 : REMark  - no equivalent
2500 DATA 176,1,230 : REMark 
2510 DATA 177,1,227 : REMark 
2520 DATA 178,1,237 : REMark 
2530 DATA 179,1,173 : REMark 
2540 DATA 180,1,168 : REMark 
2550 DATA 181,1,181 : REMark  - no equivalent
2560 DATA 182,1,182 : REMark  - no equivalent
2570 DATA 183,1,183 : REMark  - no equivalent
2580 DATA 184,1,174 : REMark 
2590 DATA 185,1,175 : REMark 
2600 DATA 186,1,248 : REMark 
2610 DATA 187,1,246 : REMark 
2620 DATA 188,1,27 : REMark 
2630 DATA 189,1,26 : REMark 
2640 DATA 190,1,24 : REMark 
2650 DATA 191,1,25 : REMark 
2660 DATA 192,1,192 : REMark convert control codes as-is
2670 DATA 193,1,193 : REMark
2680 DATA 194,1,194 : REMark
2690 DATA 195,1,195 : REMark
2700 DATA 196,1,196 : REMark
2710 DATA 197,1,197 : REMark
2720 DATA 198,1,198 : REMark
2730 DATA 199,1,199 : REMark
2740 DATA 200,1,200 : REMark
2750 DATA 201,1,201 : REMark
2760 DATA 202,1,202 : REMark
2770 DATA 203,1,203 : REMark
2780 DATA 204,1,204 : REMark
2790 DATA 205,1,205 : REMark
2800 DATA 206,1,206 : REMark
2810 DATA 207,1,207 : REMark
2820 DATA 208,1,208 : REMark
2830 DATA 209,1,209 : REMark
2840 DATA 210,1,210 : REMark
2850 DATA 211,1,211 : REMark
2860 DATA 212,1,212 : REMark
2870 DATA 213,1,213 : REMark
2880 DATA 214,1,214 : REMark
2890 DATA 215,1,215 : REMark
2900 DATA 216,1,216 : REMark
2910 DATA 217,1,217 : REMark
2920 DATA 218,1,218 : REMark
2930 DATA 219,1,219 : REMark
2940 DATA 220,1,220 : REMark
2950 DATA 221,1,221 : REMark
2960 DATA 222,1,222 : REMark
2970 DATA 223,1,223 : REMark
2980 DATA 224,1,224 : REMark
2990 DATA 225,1,225 : REMark
3000 DATA 226,1,226 : REMark
3010 DATA 227,1,227 : REMark
3020 DATA 228,1,228 : REMark
3030 DATA 229,1,229 : REMark
3040 DATA 230,1,230 : REMark
3050 DATA 231,1,231 : REMark
3060 DATA 232,1,232 : REMark
3070 DATA 233,1,233 : REMark
3080 DATA 234,1,234 : REMark
3090 DATA 235,1,235 : REMark
3100 DATA 236,1,236 : REMark
3110 DATA 237,1,237 : REMark
3120 DATA 238,1,238 : REMark
3130 DATA 239,1,239 : REMark
3140 DATA 240,1,240 : REMark
3150 DATA 241,1,241 : REMark
3160 DATA 242,1,242 : REMark
3170 DATA 243,1,243 : REMark
3180 DATA 244,1,244 : REMark
3190 DATA 245,1,245 : REMark
3200 DATA 246,1,246 : REMark
3210 DATA 247,1,247 : REMark
3220 DATA 248,1,248 : REMark
3230 DATA 249,1,249 : REMark
3240 DATA 250,1,250 : REMark
3250 DATA 251,1,251 : REMark
3260 DATA 252,1,252 : REMark
3270 DATA 253,1,253 : REMark
3280 DATA 254,1,254 : REMark
3290 DATA 255,1,255 : REMark
3300 :
3310 DEFine FuNction EXTRACT_DRIVE$(defd$,str$)
3320   LOCal a
3330   a = '_' INSTR str$
3340   SELect ON a
3350     =0 : fnm$ = str$  : RETurn defd$
3360     =REMAINDER
3370       IF a < LEN(str$) THEN
3380         fnm$=str$(a+1 TO LEN(str$))
3390       ELSE
3400         fnm$ = ''
3410       END IF
3420       RETurn str$(1 TO a)
3430     END SELect
3440 END DEFine EXTRACT_DRIVE$
